/* 	This Program takes data from PORT 0 and sends it on the serial PORT
*	The data is sent only when there is change on the port 0 data.
*	This program runs with FPGA only.
*	This code is written for USDP
*/

#include <intrins.h>
#include <reg52.h>

#define TIMER_RELOAD (-921)

typedef unsigned int UINT;
typedef unsigned char UCHAR;
typedef unsigned long ULONG;

UCHAR mult;

void serial (void)
interrupt 4 using 2
{
	if(RI)
		RI = 0;
}

void init_hw(void)
{
	TMOD = 0x21;	// timer mode
	IE = 0x92; //1001 0010	  // interrupt enable	
	SCON = 0x50; //0101 0000  // serial mode setting
	TL0 = TIMER_RELOAD;
	TH0 = TIMER_RELOAD >> 8;
	TH1 = TL1 = 0xFA; // serial baud rate generator
	TR0 = 1;
	TR1 = 1;
}

void main(void)
{
	UCHAR oldno;
	UINT i;
	init_hw();	
	oldno = 0;
	while(1)
	{
		mult =P0;
		if(oldno != mult)
		{
			SBUF = mult;
			TI = 0;
			for(i = 0; i < 500; i++);
			oldno = mult;
		}
	}
}
